<!doctype html>
<html class="no-js">
<head>



<meta charset="utf-8">
<title>Learn Python the Hard Way</title>

<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="description" content="">
<meta name="viewport" content="width=device-width,initial-scale=1">

<link href='https://fonts.googleapis.com/css?family=Source+Code+Pro|Source+Sans+Pro:200,400,700,200italic,400italic,700italic' rel='stylesheet' type='text/css'>
<link href="../css/style.min.css" rel="stylesheet">
<!-- http://www.socicon.com -->
<link href="../css/icons.css" rel="stylesheet">


</head>

<body class="baseline-grid-off book-site" id="top">




<header class="header" role="banner">
    <nav class="navbar navbar-full nav-brand-family">
        <div class="row middle-xs">
            <ul class="brand-links show-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org" class="waves-effect">Learn:</a></li>

                <li><a href="https://learncodethehardway.org/python/" class="waves-effect active">Python</a></li>

                <li><a href="https://learncodethehardway.org/ruby/" class="waves-effect">Ruby</a></li>

                <li><a href="https://learncodethehardway.org/more-python/" class="waves-effect">More Python</a></li>

                <li><a href="https://learncodethehardway.org/c/" class="waves-effect">C</a></li>

                <li><a href="https://learncodethehardway.org/sql/" class="waves-effect">SQL</a></li>

                <li><a href="https://learncodethehardway.org/javascript/" class="waves-effect">Javascript</a></li>

                <li><a href="https://learncodethehardway.org/unix/" class="waves-effect">Unix</a></li>

                <li><a href="https://learncodethehardway.org/regex/" class="waves-effect">RegEx</a></li>

                <li><a href="https://www.learndesignthehardway.com/" class="waves-effect">Design</a></li>

            </ul>
            <ul class="brand-links hide-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org/" class="waves-effect">LCTHW</a></li>
            </ul>

            <ul class="site-meta col-xs-9 col-sm-2 end-xs bare">
                <li><a href="https://shop.learncodethehardway.org/access/reactivate/" class="waves-effect"><i class="icon icon-user"></i> Login</a></li>
            </ul>

        </div>
    </nav>

    <nav class="navbar navbar-full nav-main" role="navigation">
        <div class="row between-xs center-xs middle-xs bare">
            <div class="col-xs-4 start-xs bare">
                <a href="ex42.html#" class="no-underline nav-trigger waves-effect" id="toc"><div class="transformer hamburcloser">
                        <div class="bar bar-t"></div>
                        <div class="bar bar-m-a"></div>
                        <div class="bar bar-m-b"></div>
                        <div class="bar bar-b"></div>
                </div><span class="nav-trigger_text show-sm-inline">Contents</span></a>
            </div>
            <div class="col-xs-4"><strong>&nbsp;</strong></div>
            <div class="col-xs-4 end-xs bare">
                <a href="https://helpthw.zendesk.com/hc/en-us" class="no-underline nav-trigger waves-effect" id="help"><div class="transformer questioncloser">
                        <div class="icon-question-mark"></div>
                </div><span class="nav-trigger_text show-sm-inline">Help</span></a>
            </div>
        </div>
    </nav>

</header>




<div class="wrapper">
    <div class="masthead python-background" style="background-image: url('/images/pattern-python.svg')">
        <img src="../images/logo-python.svg" alt="Learn Python The Hard Way" class="logo">
    </div>

    <aside class="sidebar sidebar-left" role="complementary">
        <nav class="side-nav-container">
            <ol class="table-of-contents">
                <h3>Table of Contents</h3>
                <li><a href="preface.html">Preface</a></li>
                <li><a href="intro.html">The Hard Way Is Easier</a></li>
                <li><a href="ex0.html">Ex0: The Setup</a></li>
                <li><a href="ex1.html">Ex1: A Good First Program</a></li>
                <li><a href="ex2.html">Ex2: Comments And Pound Characters</a></li>
                <li><a href="ex3.html">Ex3: Numbers And Math</a></li>
                <li><a href="ex4.html">Ex4: Variables And Names</a></li>
                <li><a href="ex5.html">Ex5: More Variables And Printing</a></li>
                <li><a href="ex6.html">Ex6: Strings And Text</a></li>
                <li><a href="ex7.html">Ex7: More Printing</a></li>
                <li><a href="ex8.html">Ex8: Printing, Printing</a></li>
                <li><a href="ex9.html">Ex9: Printing, Printing, Printing</a></li>
                <li><a href="ex10.html">Ex10: What Was That?</a></li>
                <li><a href="ex11.html">Ex11: Asking Questions</a></li>
                <li><a href="ex12.html">Ex12: Prompting People</a></li>
                <li><a href="ex13.html">Ex13: Parameters, Unpacking, Variables</a></li>
                <li><a href="ex14.html">Ex14: Prompting And Passing</a></li>
                <li><a href="ex15.html">Ex15: Reading Files</a></li>
                <li><a href="ex16.html">Ex16: Reading And Writing Files</a></li>
                <li><a href="ex17.html">Ex17: More Files</a></li>
                <li><a href="ex18.html">Ex18: Names, Variables, Code, Functions</a></li>
                <li><a href="ex19.html">Ex19: Functions And Variables</a></li>
                <li><a href="ex20.html">Ex20: Functions And Files</a></li>
                <li><a href="ex21.html">Ex21: Functions Can Return Something</a></li>
                <li><a href="ex22.html">Ex22: What Do You Know So Far?</a></li>
                <li><a href="ex23.html">Ex23: Read Some Code</a></li>
                <li><a href="ex24.html">Ex24: More Practice</a></li>
                <li><a href="ex25.html">Ex25: Even More Practice</a></li>
                <li><a href="ex26.html">Ex26: Congratulations, Take A Test!</a></li>
                <li><a href="ex27.html">Ex27: Memorizing Logic</a></li>
                <li><a href="ex28.html">Ex28: Boolean Practice</a></li>
                <li><a href="ex29.html">Ex29: What If</a></li>
                <li><a href="ex30.html">Ex30: Else And If</a></li>
                <li><a href="ex31.html">Ex31: Making Decisions</a></li>
                <li><a href="ex32.html">Ex32: Loops And Lists</a></li>
                <li><a href="ex33.html">Ex33: While Loops</a></li>
                <li><a href="ex34.html">Ex34: Accessing Elements Of Lists</a></li>
                <li><a href="ex35.html">Ex35: Branches and Functions</a></li>
                <li><a href="ex36.html">Ex36: Designing and Debugging</a></li>
                <li><a href="ex37.html">Ex37: Symbol Review</a></li>
                <li><a href="ex38.html">Ex38: Doing Things To Lists</a></li>
                <li><a href="ex39.html">Ex39: Dictionaries, Oh Lovely Dictionaries</a></li>
                <li><a href="ex40.html">Ex40: Modules, Classes, And Objects</a></li>
                <li><a href="ex41.html">Ex41: Learning To Speak Object Oriented</a></li>
                <li><a href="ex42.html">Ex42: Is-A, Has-A, Objects, and Classes</a></li>
                <li><a href="ex43.html">Ex43: Gothons From Planet Percal #25</a></li>
                <li><a href="ex44.html">Ex44: Inheritance Vs. Composition</a></li>
                <li><a href="ex45.html">Ex45: You Make A Game</a></li>
                <li><a href="ex46.html">Ex46: A Project Skeleton</a></li>
                <li><a href="ex47.html">Ex47: Automated Testing</a></li>
                <li><a href="ex48.html">Ex48: Advanced User Input</a></li>
                <li><a href="ex49.html">Ex49: Making Sentences</a></li>
                <li><a href="ex50.html">Ex50: Your First Website</a></li>
                <li><a href="ex51.html">Ex51: Getting Input From A Browser</a></li>
                <li><a href="ex52.html">Ex52: The Start Of Your Web Game</a></li>
                <li><a href="advice.html">Advice From An Old Programmer</a></li>
                <li><a href="next.html">Next Steps</a></li>
                <li><a href="appendixa.html">Appendix A: Command Line Crash Course</a></li>
            </ol>
            <ul class="site-links">
                <h3>Learn the Hard Way</h3>
                <li><a href="ex42.html#" class="waves-effect"><i class="icon-information"></i> About LPTHW</a></li>
                <li><a href="ex42.html#" class="waves-effect"><i class="icon-question-mark"></i> Help &amp; Support</a></li>
                <li><a href="ex42.html#" class="waves-effect"><i class="socicon-twitter"></i> Follow us on Twitter</a></li>
            </ul>
        </nav>
        <div class="colophon text-center">
            <div class="intro">
                <p class="bare-bottom">
                The type for this book is set in 18px / 1.5
                <a href="https://www.google.com/fonts/specimen/Source+Serif+Pro">Adobe Serif</a>,
                <a href="https://www.google.com/fonts/specimen/Source+Sans+Pro">Sans</a>, and
                <a href="https://www.google.com/fonts/specimen/Source+Code+Pro">Code</a>.
                </p>
            </div>
            <div class="printers-mark">
                <div class="inscription">Docendo <i class="icon-repeat"></i> Discimus</div>
            </div>
        </div>
    </aside>

    <div class="overlay"></div>

    <main class="main python" role="main">
    <div class="main-container row center-xs">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">

            <div class="content">
                <!--- RST STARTS -->
                <h1 class="title">Exercise 42: Is-A, Has-A, Objects, and Classes</h1>
                <p>An important concept that you have to understand is the difference between a class and an object.  The problem is, there is no real &quot;difference&quot; between a class and an object.  They are actually the same thing at different points in time.  I will demonstrate by a Zen koan:</p>
<pre class="literal-block">
What is the difference between a Fish and a Salmon?
</pre>
<p>Did that question sort of confuse you? Really sit down and think about it for a minute.  I mean, a Fish and a Salmon are different but, wait, they are the same thing, right?  A Salmon is a <em>kind</em> of Fish, so I mean it's not different.  But at the same time, because a Salmon is a particular <em>type</em> of Fish so it's actually different from all other Fish.  That's what makes it a Salmon and not a Halibut.  So a Salmon and a Fish are the same but different.  Weird.</p>
<p>This question is confusing because most people do not think about real things this way, but they intuitively understand them.  You do not need to think about the difference between a Fish and a Salmon because you <em>know</em> how they are related.  You know a Salmon is a <em>kind</em> of Fish and that there are other kinds of Fish without having to understand that.</p>
<p>Let's take it one step further. Let's say you have a bucket full of three Salmon and because you are a nice person, you have decided to name them Frank, Joe, and Mary.  Now, think about this question:</p>
<pre class="literal-block">
What is the difference between Mary and a Salmon?
</pre>
<p>Again this is a weird question, but it's a bit easier than the Fish versus  Salmon question.  You know that Mary is a Salmon, so she's not really different.  She's just a specific &quot;instance&quot; of a Salmon.  Joe and Frank are also instances of Salmon. What do I mean when I say instance?  I mean they were created from some other Salmon and now represent a real thing that has Salmon-like attributes.</p>
<p>Now for the mind-bending idea:  Fish is a class, and Salmon is a class, and Mary is an object.  Think about that for a second.  Let's break it down slowly and see if you get it.</p>
<p>A Fish is a class, meaning it's not a <em>real</em> thing, but rather a word we attach to instances of things with similar attributes.  Got fins? Got gills? Lives in water?  Alright it's probably a Fish.</p>
<p>Someone with a Ph.D. then comes along and says, &quot;No, my young friend, <em>this</em> Fish is actually <em>Salmo salar</em>, affectionately known as a Salmon.&quot;  This professor has just clarified the Fish further; and made a new class called &quot;Salmon&quot; that has more specific attributes.  Longer nose, reddish flesh, big, lives in the ocean or fresh water, tasty?  Probably a Salmon.</p>
<p>Finally, a cook comes along and tells the Ph.D., &quot;No, you see this Salmon right here, I'll call her Mary and I'm going to make a tasty fillet out of her with a nice sauce.&quot;  Now you have this <em>instance</em> of a Salmon (which also is an instance of a Fish) named Mary turned into something real that is filling your belly.  It has become an object.</p>
<p>There you have it: Mary is a kind of Salmon that is a kind of Fish.  object is a class is a class.</p>
<div class="section" id="how-this-looks-in-code">
<h1>How This Looks in Code</h1>
<p>This is a weird concept, but to be very honest you only have to worry about it when you make new classes, and when you use a class.  I will show you two tricks to help you figure out whether something is a class or object.</p>
<p>First, you need to learn two catch phrases &quot;is-a&quot; and &quot;has-a.&quot;  You use the phrase is-a when you talk about objects and classes being related to each other by a class relationship.  You use has-a when you talk about objects and classes that are related only because they <em>reference</em> each other.</p>
<p>Now, go through this piece of code and replace each <tt class="docutils literal"><span class="pre">##??</span></tt> comment with a comment that says whether the next line represents an is-a or a has-a relationship and what that relationship is.  In the beginning of the code, I've laid out a few examples, so you just have to write the remaining ones.</p>
<p>Remember, is-a is the relationship between Fish and Salmon, while has-a is the relationship between Salmon and Gills.</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex42.py-idio.html-1"></a><span class="c1">## Animal is-a object (yes, sort of confusing) look at the extra credit</span>
<a name="python--ex42.py-idio.html-2"></a><span class="k">class</span> <span class="nc">Animal</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
<a name="python--ex42.py-idio.html-3"></a>    <span class="k">pass</span>
<a name="python--ex42.py-idio.html-4"></a>
<a name="python--ex42.py-idio.html-5"></a><span class="c1">## ??</span>
<a name="python--ex42.py-idio.html-6"></a><span class="k">class</span> <span class="nc">Dog</span><span class="p">(</span><span class="n">Animal</span><span class="p">):</span>
<a name="python--ex42.py-idio.html-7"></a>
<a name="python--ex42.py-idio.html-8"></a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">):</span>
<a name="python--ex42.py-idio.html-9"></a>        <span class="c1">## ??</span>
<a name="python--ex42.py-idio.html-10"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">name</span>
<a name="python--ex42.py-idio.html-11"></a>
<a name="python--ex42.py-idio.html-12"></a><span class="c1">## ??</span>
<a name="python--ex42.py-idio.html-13"></a><span class="k">class</span> <span class="nc">Cat</span><span class="p">(</span><span class="n">Animal</span><span class="p">):</span>
<a name="python--ex42.py-idio.html-14"></a>
<a name="python--ex42.py-idio.html-15"></a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">):</span>
<a name="python--ex42.py-idio.html-16"></a>        <span class="c1">## ??</span>
<a name="python--ex42.py-idio.html-17"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">name</span>
<a name="python--ex42.py-idio.html-18"></a>
<a name="python--ex42.py-idio.html-19"></a><span class="c1">## ??</span>
<a name="python--ex42.py-idio.html-20"></a><span class="k">class</span> <span class="nc">Person</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
<a name="python--ex42.py-idio.html-21"></a>
<a name="python--ex42.py-idio.html-22"></a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">):</span>
<a name="python--ex42.py-idio.html-23"></a>        <span class="c1">## ??</span>
<a name="python--ex42.py-idio.html-24"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">name</span>
<a name="python--ex42.py-idio.html-25"></a>
<a name="python--ex42.py-idio.html-26"></a>        <span class="c1">## Person has-a pet of some kind</span>
<a name="python--ex42.py-idio.html-27"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">pet</span> <span class="o">=</span> <span class="bp">None</span>
<a name="python--ex42.py-idio.html-28"></a>
<a name="python--ex42.py-idio.html-29"></a><span class="c1">## ??</span>
<a name="python--ex42.py-idio.html-30"></a><span class="k">class</span> <span class="nc">Employee</span><span class="p">(</span><span class="n">Person</span><span class="p">):</span>
<a name="python--ex42.py-idio.html-31"></a>
<a name="python--ex42.py-idio.html-32"></a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">salary</span><span class="p">):</span>
<a name="python--ex42.py-idio.html-33"></a>        <span class="c1">## ?? hmm what is this strange magic?</span>
<a name="python--ex42.py-idio.html-34"></a>        <span class="nb">super</span><span class="p">(</span><span class="n">Employee</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="n">__init__</span><span class="p">(</span><span class="n">name</span><span class="p">)</span>
<a name="python--ex42.py-idio.html-35"></a>        <span class="c1">## ??</span>
<a name="python--ex42.py-idio.html-36"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">salary</span> <span class="o">=</span> <span class="n">salary</span>
<a name="python--ex42.py-idio.html-37"></a>
<a name="python--ex42.py-idio.html-38"></a><span class="c1">## ??</span>
<a name="python--ex42.py-idio.html-39"></a><span class="k">class</span> <span class="nc">Fish</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
<a name="python--ex42.py-idio.html-40"></a>    <span class="k">pass</span>
<a name="python--ex42.py-idio.html-41"></a>
<a name="python--ex42.py-idio.html-42"></a><span class="c1">## ??</span>
<a name="python--ex42.py-idio.html-43"></a><span class="k">class</span> <span class="nc">Salmon</span><span class="p">(</span><span class="n">Fish</span><span class="p">):</span>
<a name="python--ex42.py-idio.html-44"></a>    <span class="k">pass</span>
<a name="python--ex42.py-idio.html-45"></a>
<a name="python--ex42.py-idio.html-46"></a><span class="c1">## ??</span>
<a name="python--ex42.py-idio.html-47"></a><span class="k">class</span> <span class="nc">Halibut</span><span class="p">(</span><span class="n">Fish</span><span class="p">):</span>
<a name="python--ex42.py-idio.html-48"></a>    <span class="k">pass</span>
<a name="python--ex42.py-idio.html-49"></a>
<a name="python--ex42.py-idio.html-50"></a>
<a name="python--ex42.py-idio.html-51"></a><span class="c1">## rover is-a Dog</span>
<a name="python--ex42.py-idio.html-52"></a><span class="n">rover</span> <span class="o">=</span> <span class="n">Dog</span><span class="p">(</span><span class="s2">&quot;Rover&quot;</span><span class="p">)</span>
<a name="python--ex42.py-idio.html-53"></a>
<a name="python--ex42.py-idio.html-54"></a><span class="c1">## ??</span>
<a name="python--ex42.py-idio.html-55"></a><span class="n">satan</span> <span class="o">=</span> <span class="n">Cat</span><span class="p">(</span><span class="s2">&quot;Satan&quot;</span><span class="p">)</span>
<a name="python--ex42.py-idio.html-56"></a>
<a name="python--ex42.py-idio.html-57"></a><span class="c1">## ??</span>
<a name="python--ex42.py-idio.html-58"></a><span class="n">mary</span> <span class="o">=</span> <span class="n">Person</span><span class="p">(</span><span class="s2">&quot;Mary&quot;</span><span class="p">)</span>
<a name="python--ex42.py-idio.html-59"></a>
<a name="python--ex42.py-idio.html-60"></a><span class="c1">## ??</span>
<a name="python--ex42.py-idio.html-61"></a><span class="n">mary</span><span class="o">.</span><span class="n">pet</span> <span class="o">=</span> <span class="n">satan</span>
<a name="python--ex42.py-idio.html-62"></a>
<a name="python--ex42.py-idio.html-63"></a><span class="c1">## ??</span>
<a name="python--ex42.py-idio.html-64"></a><span class="n">frank</span> <span class="o">=</span> <span class="n">Employee</span><span class="p">(</span><span class="s2">&quot;Frank&quot;</span><span class="p">,</span> <span class="mi">120000</span><span class="p">)</span>
<a name="python--ex42.py-idio.html-65"></a>
<a name="python--ex42.py-idio.html-66"></a><span class="c1">## ??</span>
<a name="python--ex42.py-idio.html-67"></a><span class="n">frank</span><span class="o">.</span><span class="n">pet</span> <span class="o">=</span> <span class="n">rover</span>
<a name="python--ex42.py-idio.html-68"></a>
<a name="python--ex42.py-idio.html-69"></a><span class="c1">## ??</span>
<a name="python--ex42.py-idio.html-70"></a><span class="n">flipper</span> <span class="o">=</span> <span class="n">Fish</span><span class="p">()</span>
<a name="python--ex42.py-idio.html-71"></a>
<a name="python--ex42.py-idio.html-72"></a><span class="c1">## ??</span>
<a name="python--ex42.py-idio.html-73"></a><span class="n">crouse</span> <span class="o">=</span> <span class="n">Salmon</span><span class="p">()</span>
<a name="python--ex42.py-idio.html-74"></a>
<a name="python--ex42.py-idio.html-75"></a><span class="c1">## ??</span>
<a name="python--ex42.py-idio.html-76"></a><span class="n">harry</span> <span class="o">=</span> <span class="n">Halibut</span><span class="p">()</span>
</pre></div>
</td></tr></table></div>
<div class="section" id="about-class-name-object">
<h1>About class Name(object)</h1>
<p>Remember how I was yelling at you to always use <tt class="docutils literal">class Name(object)</tt> and I couldn't tell you why?  Now I can tell you, because you just learned about the difference between a class and an object.  I couldn't tell you until now because you would have just been confused and couldn't learn to use the technology.</p>
<p>What happened is Python's original rendition of class was broken in many serious ways.  By the time they admitted the fault it was too late, and they had to support it.  In order to fix the problem, they needed some &quot;new class&quot; style so that the &quot;old classes&quot; would keep working but you could use the new more correct version.</p>
<p>This is where &quot;<tt class="docutils literal">class <span class="pre">is-a</span> object</tt>&quot; comes in.  They decided that they would use the word &quot;object,&quot; lowercased, to be the &quot;class&quot; that you inherit from to make a class.  Confusing, right?  A class inherits from the class named object to make a class but it's not an object really it's a class, but do not forget to inherit from object.</p>
<p>Exactly. The choice of one single word meant that I couldn't teach you about this until now.  Now you can try to understand the concept of a class that is an object if you like.</p>
<p>However, I would suggest you do not.  Just completely ignore the idea of old style versus new style classes and assume that Python always requires (object) when you make a class.  Save your brain power for something important.</p>
</div>
<div class="section" id="study-drills">
<h1>Study Drills</h1>
<ol class="arabic simple">
<li>Research why Python added this strange object class, and what that means.</li>
<li>Is it possible to use a class like it's an object?</li>
<li>Fill out the animals, fish, and people in this exercise with functions that make them do things.  See what happens when functions are in a &quot;base class&quot; like <tt class="docutils literal">Animal</tt> versus in say <tt class="docutils literal">Dog</tt>.</li>
<li>Find other people's code and work out all the is-a and has-a relationships.</li>
<li>Make some new relationships that are lists and dictionaries so you can also have &quot;has-many&quot; relationships.</li>
<li>Do you think there's such thing as an &quot;is-many&quot; relationship?  Read about &quot;multiple inheritance,&quot; then avoid it if you can.</li>
</ol>
</div>
<div class="section" id="common-student-questions">
<h1>Common Student Questions</h1>
<dl class="docutils">
<dt>What are these <tt class="docutils literal">## <span class="pre">??</span></tt> comments for?</dt>
<dd>Those are &quot;fill-in-the-blank&quot; comments that you are supposed to fill in with the right &quot;is-a,&quot; &quot;has-a&quot; concepts.  Read this exercise again and look at the other comments to see what I mean.</dd>
<dt>What is the point of <tt class="docutils literal">self.pet = None</tt>?</dt>
<dd>That makes sure that the <tt class="docutils literal">self.pet</tt> attribute of that class is set to a default of <tt class="docutils literal">None</tt>.</dd>
<dt>What does <tt class="docutils literal">super(Employee, <span class="pre">self).__init__(name)</span></tt> do?</dt>
<dd>That's how you can run the <tt class="docutils literal">__init__</tt> method of a parent class reliably.  Search for &quot;python super&quot; and read the various advice on it being evil and good for you.</dd>
</dl>
</div>
                <!-- RST ENDS -->
            </div>
        </div>

        <div class="row center-xs" id="buy">
            <div class="text-center col-xs-10 col-sm-5 col-md-4">
                <h2 class="section-title__small">Buy The Python 2 Course</h2>
                <p>
                When you buy directly from the author, Zed A. Shaw, you'll get a professional
                quality PDF and  hours of HD Video, all DRM-free and yours to download.
                </p>

                <p class="price-block">
                <span class="currency"><span class="prefix">$</span>29.<span class="suffix">99</span></span>
                </p>

                <a href="https://shop.learncodethehardway.org/access/buy/2/" class="btn btn-primary btn-full">Buy The Python 2 Course</a>
                <a href="https://shop.learncodethehardway.org/access/buy/9/" class="btn btn-primary btn-full">Pre-Order The Python 3 Course Instead</a>

                <p class="text-left btn-subtext">
                <small>Or, you can <a href="https://learnpythonthehardway.org/book/book_2.html">read Learn Python the Hard Way for free</a> right here, video lectures not included.</small>
                </p>

            </div>
            <div class="text-center col-xs-10 col-sm-5 col-md-4 col-sm-offset-1">

                <h2 class="section-title__small">Other Buying Options</h2>
                <a href="http://bit.ly/amznlpthw" class="btn btn-secondary btn-full">Buy on Amazon</a>
                <a href="http://bit.ly/informitlpthw" class="btn btn-secondary btn-full">Buy a hard copy from the Publisher</a>
                <a href="http://bit.ly/bnlpthw" class="btn btn-secondary btn-full">Buy a hard copy from Barnes &amp; Noble</a>

            </div>
        </div>
    </div>

    <div class="row center-xs" id="video_holder" style="display: none">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">
            <div data-paydiv_product="2" id='paydiv'>
                No content available for this exercise.  You can view all available downloads at <a href="https://shop.learncodethehardway.org/customers/">your customer account page</a>.
            </div>
        </div>
    </div>
    </main>

</div>

<div class="row dark bottom-nav">
    <div class="col-xs text-left">
        <a href="ex42.html" class="prev" id='prev_link'><i class="icon-arrow-67"></i> <i class="icon icon-arrow-left"></i> Previous <span class="hide-xs show-sm-inline">Lesson</span></a>
    </div>
    <div class="col-xs text-right"><a href="ex42.html" class="next" id='next_link'>Next <span class="hide-xs show-sm-inline">Lesson</span> <i class="icon icon-arrow-right"></i></a>
    </div>
</div>
  </div>

<footer class="footer">
<div class="row center-xs">

    <div class="col-xs-11 col-sm-6 col-md-5 col-lg-5">
        <ul class="nav nav-inline">
            <li><h4><a href="https://learnpythonthehardway.org/learnpythonthehardway_default_2.html">Home</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/about/">About</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/contact/">Contact</a></h4></li>
        </ul>
        <div class="copyright text-left">
            <small class="text-muted">&copy; 2016 Zed A. Shaw. All rights reserved.</small>
        </div>
    </div>
    <div class="col-xs-11 col-sm-4 col-md-4 col-lg-3">
        <div class="social-media">
            <div class="classy-container">
                <a href="https://twitter.com/lzsthw" class="socicon-twitter"></a>
            </div>
        </div>
    </div>
</div>

</footer>
<script src="../js/scripts.min.js"></script>

<script src="javascripts/jquery.js"></script>
<script src="index.js"></script>
<script src="https://shop.learncodethehardway.org/static/jzed.js"></script>
<script src="https://shop.learncodethehardway.org/static/js/videojs/video.js"></script>
<link rel="stylesheet" href="https://shop.learncodethehardway.org/static/js/videojs/video-js.css">
<script src="https://shop.learncodethehardway.org/static/api/v1/paydiv.js"></script>
<script src="javascripts/app.js"></script>
<script src="javascripts/littools.js"></script>
<!-- Start of helpthw Zendesk Widget script -->
<script>/*<![CDATA[*/window.zEmbed||function(e,t){var n,o,d,i,s,a=[],r=document.createElement("iframe");window.zEmbed=function(){a.push(arguments)},window.zE=window.zE||window.zEmbed,r.src="javascript:false",r.title="",r.role="presentation",(r.frameElement||r).style.cssText="display: none",d=document.getElementsByTagName("script"),d=d[d.length-1],d.parentNode.insertBefore(r,d),i=r.contentWindow,s=i.document;try{o=s}catch(e){n=document.domain,r.src='javascript:var d=document.open();d.domain="'+n+'";void(0);',o=s}o.open()._l=function(){var o=this.createElement("script");n&&(this.domain=n),o.id="js-iframe-async",o.src=e,this.t=+new Date,this.zendeskHost=t,this.zEQueue=a,this.body.appendChild(o)},o.write('<body onload="document._l();">'),o.close()}("https://assets.zendesk.com/embeddable_framework/main.js","helpthw.zendesk.com");
/*]]>*/</script>
<!-- End of helpthw Zendesk Widget script -->
<script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
 (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
 m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
 })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-24168052-1', 'auto');
ga('send', 'pageview');

</script>

</body>
</html>
